///////////////////////////////////////////////////////////
//MY_MATH.CPP
//This file is the implementation of the functions defined 
//in the header file MY_MATH.H
//
//Author: TAO Yufei
//Last revisied: 3 Nov, 2000
///////////////////////////////////////////////////////////
#include <stdlib.h>
#include <math.h>
#include "my_math.h"
///////////////////////////////////////////////////////////


/****************************************
gen_uniform will generate a random number uniformly in the range
 [x1, x2)
Para: 
  x1 and x2 are the two bounds for the range
Precondition:
  The seed of the random number should have been set
Postcondition:
  None
*****************************************/
float gen_uniform(float x1, float x2)
{
	float x;  //x is the number to be generated
	do
	{
		x = (float) rand() / RAND_MAX;

	}while(x == 0. || x == 1.);

	x = (x2 - x1) * x +x1;

	return x;
}

/****************************************
gen_rec_sides will generate two sides with lengths constituting a rectangle with
the specified area
Para: 
  side1 and side2 will be used to contain the results
  area is the area that the rectangle should have
Precondition:
  The seed of the random number should have been set
Postcondition:
  None
*****************************************/
void gen_rec_sides(float &side1, float &side2, float area)
{
	do
	{
		float number = gen_uniform(0.0, 90.0);

		float angle  = (MY_PI * number) / 180.0;

		float tan_angle = tan(angle);
		
		side1 = sqrt(area*tan_angle);
		
		side2 = area / side1;

	}while(side1 > 1.0 || side2 > 1.0);

	
	return;
}
//---------------------------------------------------
float min(float _a, float _b)
{
	if (_a < _b) return _a; else return _b;
}
//---------------------------------------------------
float max(float _a, float _b)
{
	if (_a > _b) return _a; else return _b;
}

